Error = Class.create(function(Super)
 /**
  * G[A_v^[NX
  * @param Super [Function|null] X[p[NX
  * @return Function js.cpt.ErrorNX
  * 
  * @package js.cpt
  * @update 2007/07/14
  * @version 5.00.02
  * @author Mug
  * @copyright (C) 2004-2007 Mug, All rights reserved.
  * 
  * @explanation <p>̃NX͊eG[NX̃A_v^[Ƃċ@\B
  *   G[NX͂̃NX̃TuNXłȂ΂Ȃ炸A
  *   ̃TuNX͊eŗL̖̂ł̃NXɓo^ĎgpB
  *   ȂAʏ̓NX̏ɂ̓o^Lq邱ƂŁA
  *   [U[̓TuNXǂݍ߂Γo^sKv͂ȂB</p>
  * @example <p>TuNX<var>js.debug.jsem.NumberFormatException</var><kbd>NumberFormatException</kbd>Ƃ̂
  *   o^ȉɎB</p>
  *   <pre><code>
  *   // NumberFormatExceptionNXƂ̗
  *   js.cpt.Error.registErrorClass("NumberFormatException", js.debug.jsem.NumberFormatException);
  *   </code></pre>
  *   <p>܂A<var>js.debug.jsem.NumberFormatException</var>G[ƂăX[ȉɎB</p>
  *   <pre><code>
  *   // (Error == js.cpt.Error) ł邱ƂOƂB
  *   
  *   throw new Error("NumberFormatException", "ꏊ", message);  // message = G[bZ[W
  *   
  *   // ܂
  *   
  *   throw new Error("NumberFormatException", message);  // message = G[bZ[W
  *   </code></pre>
  * 
  * @explanation <p>̃NX̃RXgN^si܂͒ڊ֐ƂĎsjꂽƂA
  *   ̈<var>name</var>̒lœo^ꂽNX̃CX^X𐶐ĕԂB</p>
  *   <table border="1" cellspacing="0">
  *     <caption>NXo^Ƃ̈</caption>
  *     <thead>
  *       <tr><th>SCNX</th><th>(1)TuNXo^</th><th>(2)lCeBuNXo^</th></tr>
  *     </thead>
  *     <tbody>
  *       <tr><td>Error</td><td>|</td><td>"Error"|"NativeError"</td></tr>
  *       <tr><td>EvalError</td><td>|</td><td>"EvalError"</td></tr>
  *       <tr><td>RangeError</td><td>|</td><td>"RangeError"</td></tr>
  *       <tr><td>ReferenceError</td><td>|</td><td>"ReferenceError"</td></tr>
  *       <tr><td>SyntaxError</td><td>|</td><td>"SyntaxError"</td></tr>
  *       <tr><td>TypeError</td><td>|</td><td>"TypeError"</td></tr>
  *       <tr><td>URIError</td><td>|</td><td>"URIError"</td></tr>
  *       <tr><td>js.cpt.Error</td><td>"SystemError"</td><td>|</td></tr>
  *       <tr><td>@TuNXPij</td><td>"SubError"</td><td>|</td></tr>
  *       <tr><td>@@TuNXQij</td><td>"SubSubError"</td><td>|</td></tr>
  *     </tbody>
  *     <tfoot>
  *       <tr><td colspan="3">
  *         <p><var>name</var>̒lɈvNX́A܂(1)TuNXiNX܂ށjTA
  *         Ȃ(2)lCeBuNXTAłȂΎNX(<var>js.cpt.Error</var>)ƂB</p>
  *       </td></tr>
  *     </tfoot>
  *   </table>
  *   <p>̈ꕔȗꍇ<var>name</var>̈ɂẮARXgN^̐QƂ̂ƁB</p>
  * 
  * @notice <strong>ӁI</strong><p>̃NXǂݍ񂾁i<kbd>include</kbd>jꍇA
  *   ECMAScriptlCeBu<var>Error</var>IuWFNg<var>js.cpt.Error</var>ŏ㏑B</p>
  *   <p>ȂAO[oXR[v̕ϐ<var>Error</var><var>js.cpt.Error</var>łĂA
  *   <var>Error</var>RXgN^E\bḧ0`1܂́A<var>name</var><kbd>"Error"</kbd>Ƃ
  *   s邱ƂŁAECMAScriptlCeBu<var>Error</var>IuWFNgRXgN^Ƃ
  *   G[CX^X쐬邱Ƃ\łBiڍׂ̓RXgN^̐QƂ̂Ɓj</p>
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "js.cpt.Error";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  
  //##############################################################################
  //
  // {fB(vCx[gENXEStaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  //:V GlobalObj Object O[oIuWFNg
  var GlobalObj = (function() { return this; })();
  
  // lCeBuG[NX
  //:V NativeError Function gݍErrorIuWFNg
  var NativeError = Super;
  //:V EvalError Function|undefined lCeBuEvalError
  var EvalError      = ((typeof GlobalObj.EvalError) == "function") ? GlobalObj.EvalError : (function() { try { var ev = eval; ev(); } catch(e) { return e.constructor; } })();
  //:V RangeError Function|undefined lCeBuRangeError
  var RangeError     = ((typeof GlobalObj.RangeError) == "function") ? GlobalObj.RangeError : (function() { try { ([]).length = -1; } catch(e) { return e.constructor; } })();
  //:V ReferenceError Function|undefined lCeBuReferenceError
  var ReferenceError = ((typeof GlobalObj.ReferenceError) == "function") ? GlobalObj.ReferenceError : (function() { try { eval("null++;"); } catch(e) { return e.constructor; } })();
  //:V SyntaxError Function|undefined lCeBuSyntaxError
  var SyntaxError    = ((typeof GlobalObj.SyntaxError) == "function") ? GlobalObj.SyntaxError : (function() { try { eval("="); } catch(e) { return e.constructor; } })();
  //:V TypeError Function|undefined lCeBuTypeError
  var TypeError      = ((typeof GlobalObj.TypeError) == "function") ? GlobalObj.TypeError : (function() { try { new 0; } catch(e) { return e.constructor; } })();
  //:V URIError Function|undefined lCeBuURIError
  var URIError       = ((typeof GlobalObj.URIError) == "function") ? GlobalObj.URIError : (function() { try { decodeURI("%uFFFF"); } catch(e) { return e.constructor; } })();;
  // Zp ReiɂReferenceError̎擾@ႤB(ȉŕ␳)
  // Geckon uEUł́Anull++;SyntaxError    / foo();ReferenceError ƂȂB
  // InternetExplorerł́Anull++;ReferenceError / foo();TypeError      ƂȂB
  if(ReferenceError == SyntaxError)
    {
    ReferenceError = (function()
      {
      try
        {
        var ref = ("_" + Math.floor(Math.random() * (new Date()).getTime()));
        eval(ref);
        }
      catch(e)
        {
        return e.constructor;
        }
      })();
    }
  
  //:V subClassMap Object TuNX̃}bv(L[:O, l:NX)
  var subClassMap = {};
  
  //------------------------------------------------------------------------------
  function getSubClass(name)
   /**
    * o^ς݂́ĩNX́jTuNX擾
    * @param name String o^
    * @return Function|null o^ς݂̃NX
    */
    {
    var subClass = null;
    if(name && ((typeof name) == "string"))
      {
      if(subClassMap.hasOwnProperty(name) && subClassMap[name])
        {
        subClass = subClassMap[name];
        }
      }
      return subClass;
    }
  
  //------------------------------------------------------------------------------
  function getNativeError(name)
   /**
    * ECMAScriptlCeBuG[IuWFNg擾
    * @param name String G[IuWFNg
    * @return Function|null  ECMAScriptlCeBuG[IuWFNg(null:YȂ)
    * @explanation <p><kbd>name</kbd>Ŏw肳ꂽG[IuWFNgԂB
    *   擾łG[IuWFNg̖O͈ȉ̒ʂB</p>
    *   <ul>
    *     <li>Error|NativeError</li>
    *     <li>EvalError</li>
    *     <li>RangeError</li>
    *     <li>ReferenceError</li>
    *     <li>SyntaxError</li>
    *     <li>TypeError</li>
    *     <li>URIError</li>
    *   </ul>
    */
    {
    var errorClass;
    switch(name)
      {
      case "Error":
      case "NativeError":
        errorClass = NativeError;
        break;
      case "EvalError":
        errorClass = EvalError;
        break;
      case "RangeError":
        errorClass = RangeError;
        break;
      case "ReferenceError":
        errorClass = ReferenceError;
        break;
      case "SyntaxError":
        errorClass = SyntaxError;
        break;
      case "TypeError":
        errorClass = TypeError;
        break;
      case "URIError":
        errorClass = URIError;
        break;
      case null:
      default:
        errorClass = null;
        //break;
      }
    return errorClass;
    }
  
  //------------------------------------------------------------------------------
  function getErrorClass(name)
   /**
    * ErrorNX܂͂̃TuNX擾
    * @param name String o^
    * @return Function Error܂͂̃TuNX(null)
    * @explanation <p><kbd>name</kbd>Ŏw肳ꂽTuNXo^ς݂ł΂̃NXA
    *   NativeErrornłΑΉNXAłȂ΂̃NXԂB</p>
    */
    {
    var errorClass = getSubClass(name);
    if(!errorClass)
      {
      errorClass = getNativeError(name);
      }
    if(!errorClass)
      {
      errorClass = Class;
      }
    return errorClass;
    }
  
  //------------------------------------------------------------------------------
  function replaceErrorObject(sourceObject)
   /**
    * ̃NX̃CX^XɊECMAScriptlCeBuErrorNX̃CX^X쐬
    * @param sourceObject js.cpt.Error ̃NX܂̓TuNX̃CX^X
    * @return Error uCX^X
    * @explanation <p>̃\bh́AECMAScriptlCeBuErrorNX̃CX^X𐶐AgڎĂvpeBRs[B
    *   <kbd>sourceObject</kbd>̃vpeB(<kbd>name</kbd>,<kbd>message</kbd>,<kbd>description</kbd>,<kbd>cause</kbd>)
    *   Rs[A<kbd>toString()</kbd>\bhʂɃI[o[ChĎ̂ԂB</p>
    */
    {
    var errorObject = new NativeError(sourceObject.message);
    for(var i in sourceObject)
      {
      switch(typeof sourceObject[i])
        {
        case "boolean":
        case "number":
        case "string":
        case "object":
          try
            {
            if(sourceObject.hasOwnProperty(i))
              {
              errorObject[i] = sourceObject[i];
              }
            }
          catch(e)
            {
            // ignore.
            }
          break;
        case "function":
        default:
        }
      }
    errorObject.name = sourceObject.name;
    errorObject.cause = sourceObject.cause;
    errorObject.toString = function()
      {
      return sourceObject.toString.apply(sourceObject, arguments);
      };
    return errorObject;
    }
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  //:C needToReturnNativeError Boolean ErrorNXKԂKv邩ǂ
  Class.needToReturnNativeError = false;  // ZpFꕔ̃Rei(IE)ł́ANativeError̃CX^XłȂcatchȂG[throwłȂB
  
  //------------------------------------------------------------------------------
  Class.getRegistedSubClass = function(name)
   /**
    * o^ς݂̃TuNX擾
    * @param name String o^
    * @return Function|null o^ς݂̃TuNX
    */
    {
    var subClass = null;
    if(name && ((typeof name) == "string"))
      {
      subClass = getSubClass(name);
      }
    return subClass;
    };
  
  //------------------------------------------------------------------------------
  Class.registErrorClass = function(name, errorClass)
   /**
    * G[NXĩNX̃TuNXjo^
    * @param name String o^
    * @param errorClass Function ̃NX̃TuNX
    * @return Boolean o^ɐǂ
    * @explanation <p>ɓo^ς݂̖OŎsꂽꍇAo^ς݂̃NX㏑ēo^B</p>
    */
    {
    if(!name || ((typeof name) != "string"))
      {
      return false;
      }
    if(!errorClass || ((typeof errorClass) != "function"))
      {
      return false;
      }
    if(!(errorClass.prototype instanceof Class))
      {
      return false;
      }
    subClassMap[name] = errorClass;
    return true;
    };
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //:P name String G[
  Proto.name = "SystemError";
  
  //------------------------------------------------------------------------------
  Proto.toString = function()
   /**
    * G[IuWFNg̕\擾
    * @return String G[Tv
    */
    {
    var msg = "";
    if(this.name || ((typeof this.name) == "string"))
      {
      msg += this.name;
      }
    if(this.cause || ((typeof this.cause) == "string"))
      {
      msg += " (" + this.cause + ") ";
      }
    if(this.message || ((typeof this.message) == "string"))
      {
      msg += ":" + this.message;
      }
    return msg;
    };
  
  //
  //  - NX`ɂP񂾂s
  //
  // G[NX̓o^
  Class.registErrorClass(Proto.name, Class);
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class(name, cause, message)
   /**
    * ErrorNX̃RXgN^
    * @param name [String] G[^Cv
    * @param cause [String] G[
    * @param message [String|Array|Error|Object] G[bZ[W܂̓G[IuWFNg
    * @return Error G[CX^X
    * @explanation <p>ꕔ̈ȗꍇAȉ̂悤ɉ߂B<br />
    *   <table border="1" cellspacing="0">
    *     <thead>
    *       <tr><th></th><th>name</th><th>place</th><th>message</th><th>Ӗ</th></tr>
    *     </thead>
    *     <tbody>
    *       <tr><th>R</th><td>P</td><td>Q</td><td>R</td><td><kbd>Error(name, place, message)</kbd></td></tr>
    *       <tr><th>Q</th><td>P</td><td><kbd>null</kbd></td><td>Q</td><td><kbd>Error(name, message)</kbd></td></tr>
    *       <tr><th>P</th><td><kbd>null</kbd></td><td><kbd>null</kbd></td><td>P</td><td><kbd>Error(message)</kbd></td></tr>
    *       <tr><th>O</th><td><kbd>null</kbd></td><td><kbd>null</kbd></td><td><kbd>null</kbd></td><td><kbd>Error()</kbd></td></tr>
    *     </tbody>
    *   </table>
    *   </p>
    * @notice <p><kbd>new</kbd>Zq𔺂ăRXgN^ƂĎsꂽꍇƁA֐ƂĎsꂽꍇł͍͂ȂA
    *   <em><kbd>new</kbd>Zq𔺂ăCX^X邱Ƃ𐄏</em>B
    *   i֐ƂĎsꂽꍇ<kbd>new</kbd>ZqtăRXgN^ĂтȂ߁Bj</p>
    * @notice <p>̃\bh͖߂lϊĕԂƂB
    *   ߂lϊ͈̂ȉ̏1`3SĖꍇłB<br />
    *   <ol>
    *     <li>̃NX<kbd>Class</kbd><kbd>needToReturnNativeError</kbd>̒l<kbd>true</kbd>łiƉ߂łj</li>
    *     <li><kbd>this</kbd>l̃NX̃CX^Xł</li>
    *     <li><kbd>this.constructor</kbd>l̃NXł</li>
    *   </ol>
    *   ł̏23́ÃNX̃RXgN^<kbd>new</kbd>Ă邱ƂvĂB
    *   i߂lƂė\肵ĂIuWFNg̃NX̃CX^Xł邩ǂ͖ȂBj</p>
    *   <p>̏𖞂ꍇAECMAScriptgݍ݃IuWFNg<kbd>Error</kbd>̃CX^XĖ߂lƂĒuB
    *   ̒ûƂA̖߂lIuWFNg̑(<kbd>name</kbd>,<kbd>message</kbd>,<kbd>description</kbd>)Rs[A
    *   \bh<kbd>toString()</kbd>i߂l̃\bhs悤Ɂj㏑ĎB</p>
    */
    {
    // iZpFcausearguments[1]ĂBj
    switch(arguments.length)
      {
      case 0:
        message = null;
        cause = null;
        name = null;
        break;
      case 1:
        message = arguments[0];
        cause = null;
        name = null;
        break;
      case 2:
        message = arguments[1];
        cause = null;
        break;
      default:
      }
    // s@
    var returnValue;
    // \bhƂĎs or newꂽicFTuNXnewꂽj
    if(!(this instanceof Class) || (this.constructor == Class))
      {
      var ErrorClass = getErrorClass(name);
      // TuNXԋp
      if(ErrorClass.prototype instanceof Class)
        {
        returnValue = new ErrorClass(cause, message);
        }
      // X[p[NXԋp
      else if(ErrorClass != Class)
        {
        returnValue = new ErrorClass(message);
        }
      // NXԋp and \bhďo
      else if(!(this instanceof Class))
        {
        returnValue = new Class(name, cause, message);
        }
      // else : NXԋp and newꂽ
      }
    // lXgnewCX^XȊOԋpꍇ
    if(returnValue)
      {
      // ߂lϊ
      if(Class.needToReturnNativeError && (this instanceof Class) && (this.constructor == Class))
        {
        returnValue = replaceErrorObject(returnValue);
        }
      return returnValue;
      }
    // ܂ŔĂ̂́ÃNX܂̓TuNX̃RXgN^newꂽƂB
    // bZ[Wm
    if((typeof message) != "string")
      {
      message = "" + message;
      }
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    Super.call(this, message);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    //:v returnValue Error ԋpliϊȂꍇthislj
    returnValue = this;
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    //:i name [String] namevg^CvƈقȂꍇɐݒ
    if(name && (this instanceof Class))
      {
      if((typeof name) != "string")
        {
        name = "" + name;
        }
      if(this.name != name)
        {
        this.name = name;
        }
      }
    //:i cause [String] causevg^CvƈقȂꍇɐݒ
    if((cause != null) && (cause != undefined) && ((typeof cause) != "string"))
      {
      cause = "" + cause;
      }
    this.cause = cause;
    //:i message [String] messagevg^CvƈقȂꍇɐݒ
    if(this.message != message)
      {
      this.message = message;
      }
    // ߂lϊ
    if(Class.needToReturnNativeError && (this instanceof Class) && (this.constructor == Class))
      {
      returnValue = replaceErrorObject(returnValue);
      }
    return returnValue;
    }
  
  return Class;
  }, Error);

